package com.liang.dao;

import com.liang.entity.StaOutttesting;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 外协测试试验与加工费(StaOutttesting)表数据库访问层
 *
 * @author makejava
 * @since 2023-07-18 21:55:16
 */
public interface StaOutttestingDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaOutttesting queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staOutttesting 查询条件
     * @param pageable       分页对象
     * @return 对象列表
     */
    List<StaOutttesting> queryAllByLimit(StaOutttesting staOutttesting, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staOutttesting 查询条件
     * @return 总行数
     */
    long count(StaOutttesting staOutttesting);

    /**
     * 新增数据
     *
     * @param staOutttesting 实例对象
     * @return 影响行数
     */
    int insert(StaOutttesting staOutttesting);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaOutttesting> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaOutttesting> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaOutttesting> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaOutttesting> entities);

    /**
     * 修改数据
     *
     * @param staOutttesting 实例对象
     * @return 影响行数
     */
    int update(StaOutttesting staOutttesting);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取列表
     *
     * @return
     */
    List<StaOutttesting> getWxcsList(Integer zb);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);

}

